/* mixvars.c */
/*
     PLAY_ITW.EXE v0.02b : Player for Impulse Tracker modules files
     Copyright (C) 1997  Olivier AUMAGE
     E-mail : Olivier.Aumage@ens-lyon.fr
     Web : http://www.ens-lyon.fr/~oaumage/

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "mixtypes.h"

p_module pointer_on_current_module ;

int new_note_actions_activated ;
double mixing_volume ;
unsigned char global_volume ;
unsigned char global_volume_slide_on ;
unsigned char global_volume_slide_value ;
unsigned char last_global_volume_slide_parameter ;

unsigned char current_order ;
unsigned char current_pattern ;
unsigned char current_line ;
unsigned char current_frame ;
unsigned long current_sample ;

unsigned long samples_per_frame ;
unsigned char frames_per_line ;
unsigned char beats_per_minute ;
unsigned long samples_per_minutes ;
unsigned long frames_per_beats = 24UL ;

p_pattern pointer_on_current_pattern ;
unsigned char *pointer_on_current_pattern_byte ;

p_virtual_channel virtual_channels[256] ;
unsigned short number_of_virtual_channels_allocated ; /* 0 -> 256 */
unsigned short max_number_of_virtual_channels_allocated ; /* 0 -> 256 */

real_channel real_channels[64] ; /* this array is an array of structures
                                           whereas the 'virtual_channels' array
                                           is an array of pointers
                                        */

double precalculated_notes_table [16384] ;
unsigned char precalculated_note_shift_value ;
char last_pattern ;
char last_line ;
char last_frame ;
int volume_ramp_on_off ;
unsigned short volume_ramp_length ;
int loop_allowed ;
